Subject: Re: [PATCH 1/2] PCI: Ensure error recoverability at all times

From: Lukas Wunner <[email-masked]>
Date: Fri, 21 Nov 2025 18:40:23 +0100

On Thu, Nov 13, 2025 at 10:15:56AM -0600, Bjorn Helgaas wrote:
> On Thu, Nov 13, 2025 at 10:38:09AM +0100, Lukas Wunner wrote:
> > On Wed, Nov 12, 2025 at 04:38:31PM -0600, Bjorn Helgaas wrote:
> > > On Sun, Oct 12, 2025 at 03:25:01PM +0200, Lukas Wunner wrote:
> > > It would be nice if there were a few more
> > > words about pci_save_state() and pci_restore_state() in
> > > Documentation/.
> > > 
> > > pci_save_state() isn't mentioned at all in Documentation/PCI
> > 
> > Right, it's documented in the Documentation/power directory. :)
> 
> Yes, in the pci.rst I mentioned, but it mostly uses the "saves the
> device's standard configuration registers" wording.
> 
> I'm just wishing for a more concrete mention of "pci_save_state()",
> since that's where the critical "state_saved" flag is updated.

Hm, Documentation/power/pci.rst does contain this:

   "Then, pci_save_state(), pci_prepare_to_sleep(), and
    pci_set_power_state() should be used to save the device’s
    standard configuration registers, to prepare it for system wakeup
    (if necessary), and to put it into a low-power state, respectively."

I'm struggling to find a better way to phrase it.

> And I'm not sure Documentation/ includes anything about the idea of
> a driver using pci_save_state() to capture the state it wants to
> restore after an error.

Right, while pci_save_state() usage is mentioned in the PCI power
management documentation, it's not mentioned at all in the error
recovery context.  So I'm proposing this amendment:

https://lore.kernel.org/r/[email-masked]/

Thanks,

Lukas